# -*- coding: utf-8 -*-
"""
/***************************************************************************
 Orbit3DMapping
                                 A QGIS plugin
 The 3D Mapping plugin for QGIS
 Generated by Plugin Builder: http://g-sherman.github.io/Qgis-Plugin-Builder/
                              -------------------
        begin                : 2018-11-06
        git sha              : $Format:%H$
        copyright            : (C) 2018 by Orbit Geospatial Technologies
        email                : support@orbitgt.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
"""
import subprocess
import webbrowser
from PyQt5.QtCore import QSettings, QTranslator, qVersion, QCoreApplication, Qt
from PyQt5.QtGui import QIcon
from PyQt5.QtWidgets import QAction, QMessageBox
# Initialize Qt resources from file resources.py
from .resources import *

import os.path

# Orbit addition
from .com.orbitgis.tool.message.Message import Message

class Orbit3DMapping:
    """QGIS Plugin Implementation."""

    def __init__(self, iface):
        """Constructor.

        :param iface: An interface instance that will be passed to this class
            which provides the hook by which you can manipulate the QGIS
            application at run time.
        :type iface: QgsInterface
        """
        # Save reference to the QGIS interface
        self.iface = iface

        # initialize plugin directory
        self.plugin_dir = os.path.dirname(__file__)

        # initialize locale
        locale = QSettings().value('locale/userLocale')[0:2]
        locale_path = os.path.join(
            self.plugin_dir,
            'i18n',
            'Orbit3DMapping_{}.qm'.format(locale))

        if os.path.exists(locale_path):
            self.translator = QTranslator()
            self.translator.load(locale_path)

            if qVersion() > '4.3.3':
                QCoreApplication.installTranslator(self.translator)

        # Declare instance attributes
        self.actions = []
        self.menu = self.tr(u'&Orbit 3DMapping')
        # TODO: We are going to let the user set this up in a future iteration
        self.toolbar = self.iface.addToolBar(u'Orbit3DMapping')
        self.toolbar.setObjectName(u'Orbit3DMapping')

        #print "** INITIALIZING Orbit3DMapping"

        self.pluginIsActive = False
        
        self.pluginQGIS = None


    # noinspection PyMethodMayBeStatic
    def tr(self, message):
        """Get the translation for a string using Qt translation API.

        We implement this ourselves since we do not inherit QObject.

        :param message: String for translation.
        :type message: str, QString

        :returns: Translated version of message.
        :rtype: QString
        """
        # noinspection PyTypeChecker,PyArgumentList,PyCallByClass
        return QCoreApplication.translate('Orbit3DMapping', message)


    def add_action(
        self,
        icon_path,
        text,
        callback,
        enabled_flag=True,
        add_to_menu=True,
        add_to_toolbar=True,
        status_tip=None,
        whats_this=None,
        parent=None):
        """Add a toolbar icon to the toolbar.

        :param icon_path: Path to the icon for this action. Can be a resource
            path (e.g. ':/plugins/foo/bar.png') or a normal file system path.
        :type icon_path: str

        :param text: Text that should be shown in menu items for this action.
        :type text: str

        :param callback: Function to be called when the action is triggered.
        :type callback: function

        :param enabled_flag: A flag indicating if the action should be enabled
            by default. Defaults to True.
        :type enabled_flag: bool

        :param add_to_menu: Flag indicating whether the action should also
            be added to the menu. Defaults to True.
        :type add_to_menu: bool

        :param add_to_toolbar: Flag indicating whether the action should also
            be added to the toolbar. Defaults to True.
        :type add_to_toolbar: bool

        :param status_tip: Optional text to show in a popup when mouse pointer
            hovers over the action.
        :type status_tip: str

        :param parent: Parent widget for the new action. Defaults None.
        :type parent: QWidget

        :param whats_this: Optional text to show in the status bar when the
            mouse pointer hovers over the action.

        :returns: The action that was created. Note that the action is also
            added to self.actions list.
        :rtype: QAction
        """

        icon = QIcon(icon_path)
        action = QAction(icon, text, parent)
        action.triggered.connect(callback)
        action.setEnabled(enabled_flag)

        if status_tip is not None:
            action.setStatusTip(status_tip)

        if whats_this is not None:
            action.setWhatsThis(whats_this)

        if add_to_toolbar:
            self.toolbar.addAction(action)

        if add_to_menu:
            self.iface.addPluginToMenu(
                self.menu,
                action)

        self.actions.append(action)

        return action


    def initGui(self):
		# Read the icons
        self.openPluginIconOff = QIcon(':/plugins/orbit_3dmapping/icons/SDK-Plugin-Toolbar-0-Power-Off.png')
        self.openPluginIconOn = QIcon(':/plugins/orbit_3dmapping/icons/SDK-Plugin-Toolbar-0-Power-On.png')
        self.showFootprintsIconDisabled = QIcon(':/plugins/orbit_3dmapping/icons/SDK-Plugin-Toolbar-1-Footprints-Disabled.png')
        self.showFootprintsIconEnabled = QIcon(':/plugins/orbit_3dmapping/icons/SDK-Plugin-Toolbar-1-Footprints-Enabled.png')
        # Create the toolbar actions
        self.openPluginAction = self.add_action(
            ':/plugins/orbit_3dmapping/icons/SDK-Plugin-Toolbar-0-Power-Off.png',
            text=self.tr(u'Open the 3D Mapping viewer'),
            callback=self.doOpenPlugin,
            parent=self.iface.mainWindow())
        self.showFootprintsAction = self.add_action(
            ':/plugins/orbit_3dmapping/icons/SDK-Plugin-Toolbar-1-Footprints-Enabled.png',
            text=self.tr(u'Show or hide the footprints'),
            callback=self.doShowFootprints,
            parent=self.iface.mainWindow())
        self.pickLocationAction = self.add_action(
            ':/plugins/orbit_3dmapping/icons/SDK-Plugin-Toolbar-2-PickLocation.png',
            text=self.tr(u'Pick a location on the map canvas to open in the viewer'),
            callback=self.doPickLocation,
            parent=self.iface.mainWindow())
        self.addOverlaysAction = self.add_action(
            ':/plugins/orbit_3dmapping/icons/SDK-Plugin-Toolbar-4-Overlays.png',
            text=self.tr(u'Add the selected objects as overlays to the viewer'),
            callback=self.doAddOverlays,
            parent=self.iface.mainWindow())
        self.saveMeasurementAction = self.add_action(
            ':/plugins/orbit_3dmapping/icons/SDK-Plugin-Toolbar-3-SaveObjects.png',
            text=self.tr(u'Add the measurements to the active layer'),
            callback=self.doSaveMeasurement,
            parent=self.iface.mainWindow())
        self.helpAction = self.add_action(
            ':/plugins/orbit_3dmapping/icons/SDK-Plugin-Toolbar-5-HelpHome.png',
            text=self.tr(u'Open the help pages'),
            callback=self.doHelp,
            parent=self.iface.mainWindow())
        # Set the initial state
        self.showFootprintsState = True
        self.showFootprintsAction.setEnabled(False)
        self.pickLocationAction.setEnabled(False)
        self.addOverlaysAction.setEnabled(False)
        self.saveMeasurementAction.setEnabled(False)

    #--------------------------------------------------------------------------

    def unload(self):
        """Removes the plugin menu item and icon from QGIS GUI."""

        #print "** UNLOAD Orbit3DMapping"

        if (self.pluginQGIS!=None):
            self.pluginQGIS.close()
            self.pluginQGIS = None

        for action in self.actions:
            self.iface.removePluginMenu(
                self.tr(u'&Orbit 3DMapping'),
                action)
            self.iface.removeToolBarIcon(action)
        # remove the toolbar
        del self.toolbar

    #--------------------------------------------------------------------------

    def run(self):
        """Run method that loads and starts the plugin"""

        if not self.pluginIsActive:
            self.pluginIsActive = True

            #print "** STARTING Orbit3DMapping"

	# Orbit addition
	#
    #--------------------------------------------------------------------------

    def doOpenPlugin(self):
        self.openPluginAction.setIcon(self.openPluginIconOn)
        if (self.pluginQGIS==None):
            Message.print(__name__,"Starting viewer")
            # check if the websockets package is available, and try to install with user privileges
            try:
                from .pluginqgis.PluginQGIS import PluginQGIS
            except ImportError as e:
                Message.printError(__name__,e,"Import error (phase 1) while starting the viewer")
                QMessageBox.information(None, "3D Mapping", "The 3D Mapping plugin needs to install some additional software")
                pluginDir = os.path.dirname(os.path.realpath(__file__))
                Message.print(__name__,"The plugin dir is '"+pluginDir+"'")
                Message.print(__name__,"Installing the websockets package using pip")
                process = subprocess.Popen(["pip","install","websockets"], cwd=pluginDir)
                Message.print(__name__,"...waiting for the install to finish")
                process.wait()
                returnCode = process.returncode
                Message.print(__name__,"Installed the websockets package, return code is: "+str(returnCode))
            # check if the websockets package is available, and try to install with adminstrator privileges
            try:
                from .pluginqgis.PluginQGIS import PluginQGIS
            except ImportError as e:
                Message.printError(__name__,e,"Import error (phase 2) while starting the viewer")
                env_OSGEO4W_ROOT = os.environ['OSGEO4W_ROOT']
                pluginDir = os.path.dirname(os.path.realpath(__file__))
                batchFileName = pluginDir+"\\install_plugin.bat"
                Message.print(__name__,"Writing batch file '"+batchFileName+"'")
                Message.print(__name__,"OSGEO4W_ROOT="+env_OSGEO4W_ROOT)
                batchFile = open(batchFileName,"w")
                batchFile.write("rem\n")
                batchFile.write("rem Run this batch file as an administrator by right-clicking and choosing the appropriate menu action\n")
                batchFile.write("rem\n")
                batchFile.write("set OSGEO4W_ROOT="+env_OSGEO4W_ROOT+"\n") # no quotes needed, even when spaces are present
                batchFile.write("cd \"%OSGEO4W_ROOT%\"\n")
                batchFile.write("call \"%OSGEO4W_ROOT%\\bin\\py3_env.bat\"\n")
                batchFile.write("cd \"%PYTHONHOME%\"\n")
                batchFile.write("python -m pip install websockets\n")
                batchFile.write("pause\n")
                batchFile.close()
                QMessageBox.information(None, "3D Mapping", "Please right-click the 'install_plugin.bat' file in the upcoming explorer window and choose 'Run as administrator' to finish the install")
                process = subprocess.Popen(["explorer.exe","/select,"+batchFileName], cwd=pluginDir)
                process.wait()
                QMessageBox.information(None, "3D Mapping", "Press the ok button after you finished running the install as administrator")
            # double-check if the websockets package is available
            try:
                from .pluginqgis.PluginQGIS import PluginQGIS
            except ImportError as e:
                Message.printError(__name__,e,"Import error (phase 3) while starting the viewer")
                QMessageBox.information(None, "3D Mapping", "The 3D Mapping plugin failed to install the required software")
                return
            self.pluginQGIS = PluginQGIS(self.iface,self.plugin_dir)
            self.showFootprintsAction.setEnabled(True)
            self.pickLocationAction.setEnabled(True)
            self.saveMeasurementAction.setEnabled(True)
            self.addOverlaysAction.setEnabled(True)
            Message.print(__name__,"Started viewer")
        else:
            Message.print(__name__,"Restarting viewer")
            self.pluginQGIS.restart()

    def doShowFootprints(self):
        Message.print(__name__,"doShowFootprints")
        if (self.pluginQGIS==None): return
        if (self.showFootprintsState==True):
            self.showFootprintsAction.setIcon(self.showFootprintsIconDisabled)
            self.showFootprintsState = False
        else:
            self.showFootprintsAction.setIcon(self.showFootprintsIconEnabled)
            self.showFootprintsState = True
        self.pluginQGIS.doShowFootprints(self.showFootprintsState)

    def doPickLocation(self):
        Message.print(__name__,"doPickLocation")
        if (self.pluginQGIS==None): return
        self.pluginQGIS.doPickLocation()

    def doSaveMeasurement(self):
        Message.print(__name__,"doSaveMeasurement")
        if (self.pluginQGIS==None): return
        self.pluginQGIS.doSaveMeasurement()

    def doAddOverlays(self):
        Message.print(__name__,"doAddOverlays")
        if (self.pluginQGIS==None): return
        self.pluginQGIS.doAddOverlays()

    def doHelp(self):
        Message.print(__name__,"doHelp")
        helpURL = "https://www.orbitgt.com/kb/"
        webbrowser.open(helpURL)
